Description

I encountered this error while working on a prototype for a future deployment, this isn't a high priority issue for me, but it looks like a

fairly general problem that would need to be fixed in the salt plugin before it is ready for 1.12 .

Host is Ubuntu 16.04, foreman nightly, foreman-salt v 5.0.1.

Steps performed until bug occurred:

1. Normal Foreman-installer setup, smart proxy setup, provision setup.

2. Followed docs in foreman-salt manual for 5.0 setup after enabling the nightly repository for plugins.

3. Set up salt master with some basic environments, added a single simple haproxy class.

4. Go to salt states page in foreman, click to import from proxy.

5. Select class, click submit.

Both the environments page and the states page now return similar errors (differing only in the 'search' param):

Oops, we're sorry but something went wrong No route matches {:action=>"index", :controller=>"forem

an_salt/hosts", :search=>"salt_state = haproxy"}

 Full trace is attached.

Debug at:

http://debugs.theforeman.org/foreman-debug-mGvAX.tar.xz

If you need any more information, or want me to apply/test any patches, I'll try and keep and eye on this issue.

Associated revisions

Revision 0cdd6598 - 06/02/2016 03:44 PM - Dominic Cleal

fixes #15250 - ignore current controller from link_to/hash_for

When link_to generates a link on a page served from a nested controller

(e.g. foreman_example/examples) with a hash of controller/action from

our hash_for_*_path extension, it calls url_for which added the current

controller prefix to the controller name, and this wouldn't exist.

When linking to hash_for_hosts_path (`:controller => 'hosts', :action =>

'index'`), this would attempt to link to `:controller =>

'foreman_example/hosts'` instead. By returning :use_route from hash_for

as in Rails 4.1, actionpack assumes the controller name is absolute and

will not add the current controller prefix.

Rails source where relative controller is assumed by url_for if no named

route was given (the :use_route option):

https://github.com/rails/rails/blob/v4.2.6/actionpack/lib/action_dispatch/routing/route_set.rb#L695-L698

Rails 4.1 source where :use_route was always added:
http://debugs.theforeman.org/foreman-debug-mGvAX.tar.xz
https://github.com/rails/rails/blob/v4.1.14.2/actionpack/lib/action_dispatch/routing/route_set.rb#L289-L294

Revision 1d5b4e49 - 06/03/2016 11:40 AM - Dominic Cleal

fixes #15250 - ignore current controller from link_to/hash_for

When link_to generates a link on a page served from a nested controller

(e.g. foreman_example/examples) with a hash of controller/action from

our hash_for_*_path extension, it calls url_for which added the current

controller prefix to the controller name, and this wouldn't exist.

When linking to hash_for_hosts_path (`:controller => 'hosts', :action =>

'index'`), this would attempt to link to `:controller =>

'foreman_example/hosts'` instead. By returning :use_route from hash_for

as in Rails 4.1, actionpack assumes the controller name is absolute and

will not add the current controller prefix.

Rails source where relative controller is assumed by url_for if no named

route was given (the :use_route option):

https://github.com/rails/rails/blob/v4.2.6/actionpack/lib/action_dispatch/routing/route_set.rb#L695-L698

Rails 4.1 source where :use_route was always added:

https://github.com/rails/rails/blob/v4.1.14.2/actionpack/lib/action_dispatch/routing/route_set.rb#L289-L294

(cherry picked from commit 0cdd6598dfafe5d841047a3171b08e7730453340)

History

#1 - 06/01/2016 04:49 AM - Anonymous

- Project changed from Salt to Foreman

- translation missing: en.field_release set to 136

per IRC: <Dominic> mmoll: it might be a bug in our hash_for_*path monkey patch, since controller should be "hosts" and not prefixed with the engine

name foreman_salt/.

#2 - 06/01/2016 04:51 AM - Dominic Cleal

- Category set to Rails

#3 - 06/01/2016 10:09 AM - Dominic Cleal

- Status changed from New to Assigned

- Assignee set to Dominic Cleal

#4 - 06/01/2016 10:27 AM - Dominic Cleal

hash_for is no longer returning the :use_route key in the hash on 1.12, which causes some caching ("recall") in

actionpack/lib/action_dispatch/routing/route_set.rb to try and prepend foreman_salt/ to the controller name, assuming that "hosts" is relative to the

current foreman_salt/environments controller.

1.11 hash_for returns:

=> {:action=>"index", :controller=>"hosts", :use_route=>"hosts", :only_path=>true, :search=>"salt_environment 

= ..."}

 develop:

=> {:controller=>"hosts", :action=>"index", :search=>"salt_environment = ..."}

 Edit: not "caching" as I said above, but actually it's the current controller name/prefix that's being prepended to the :controller given in the hash. It's

treated as a relative controller name unless use_route is also given.

#5 - 06/02/2016 05:12 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/3564 added

#6 - 06/02/2016 05:48 AM - Dominic Cleal

Thanks for taking the time to test nightlies/1.12 and report this issue, I expect the fix will be in an early 1.12 RC. The one-line patch linked in the pull

request can also easily be applied to /usr/share/foreman/config/initializers/routing_hash_for.rb.
#7 - 06/02/2016 09:55 AM - Alex Thompson

Thanks for the quick work! Applying the patch on my end does indeed fix the problem.

#8 - 06/02/2016 04:01 PM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 0cdd6598dfafe5d841047a3171b08e7730453340.

Files
